\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{book}}
\ProcessOptions

\LoadClass[a4paper]{book}
\RequirePackage[T1]{fontenc}
\RequirePackage[latin1]{inputenc}
\RequirePackage{graphicx}
\RequirePackage{fancyhdr}
\RequirePackage{fancybox}
\RequirePackage{amsmath}
\RequirePackage{amssymb}
\RequirePackage{amsfonts}
\RequirePackage{subfigure}
\RequirePackage{psfrag}
\RequirePackage{multirow}
\RequirePackage[colorlinks,urlcolor=ocre,linkcolor=ocre,linktocpage=true,dvips,bookmarks=true,pagebackref,breaklinks=true]{hyperref}
\RequirePackage{array}
\RequirePackage[square,numbers]{natbib}
\RequirePackage{rotating}
\RequirePackage[frenchb]{babel}
\frenchbsetup{IndentFirst=false}
%\RequirePackage{upgreek}
\RequirePackage{pst-func,pst-eucl,pst-coil,pst-plot,pst-math,pst-text}
\RequirePackage{pst-bspline,pstricks-add}

% definition de couleurs pour les liens Hyperref dans le texte
\definecolor{plo}{RGB}{225,103,0}
\definecolor{grayy}{RGB}{225,225,225}
\definecolor{grayF}{RGB}{225,225,225}
\definecolor{plg}{rgb}{0.1,0.7,0.1}
\definecolor{colorsection}{RGB}{81,81,66}
\definecolor{colorsubsection}{RGB}{101,101,86}
\definecolor{colorsubsubsection}{RGB}{121,121,106}
\definecolor{colorparagraph}{RGB}{0,0,0}
\definecolor{colorChapNum}{RGB}{91,91,76}
\definecolor{ocre}{RGB}{243,102,25}

% dfinition du d romain de drivation
\newcommand{\ud}{\mathop{\mathrm{{}d\!}}\mathopen{}}

% paramtres de la table des matires
\setcounter{tocdepth}{1}
\setcounter{secnumdepth}{2}

% dfinition des captions des objets flottants
\newcommand{\chapternumfont}{\normalfont\fontsize{50}{30}\bfseries\selectfont}
\newcommand{\annexnumfont}{\normalfont\fontsize{50}{15}\bfseries\selectfont}

% dfinition de l'entte des chapitres non numrots
\newcommand{\StarChapter}[2][]{
\chapter*{\vspace*{-60\p@}\raggedleft\bfseries\Huge\sffamily #1 \vspace*{50\p@}}
\addcontentsline{toc}{chapter}{#2}
\markboth{\normalfont\sffamily #2}{}
\par}

% dfinition de l'entte de la table des matires
\renewcommand{\tableofcontents}{\pagestyle{empty}
\chapter*{\vspace*{-60\p@}\raggedleft\bfseries\Huge\sffamily\contentsname\vspace*{50\p@}}
\@starttoc{toc}}

% dfinition de l'entte des chapitres
\def\@makechapterhead#1{%
\vspace*{-20\p@}
  { \raggedright \normalfont\sffamily
    \ifnum \c@secnumdepth >\m@ne
      \if@mainmatter
          \raggedleft\bfseries\chapternumfont\psframebox[linearc=0.2,linewidth=2pt,linecolor=ocre,cornersize=absolute,framesep=15pt]{\textcolor{ocre}{\thechapter}}\par\nobreak
          \vspace*{20pt}
        \fi
      \fi
    \begin{flushright}\begin{minipage}[t]{14cm}\raggedleft\Huge\bfseries\sffamily #1\end{minipage}\end{flushright}
    \vspace*{50\p@}%
}}

% dfinition de la bibliographie
\renewenvironment{thebibliography}[1]{
\setlength{\parindent}{0cm}
\chapter*{\vspace*{-60\p@}\raggedleft\bfseries\Huge\sffamily Rfrences \vspace*{50\p@}}
\markboth{\normalfont\normalsize\sffamily Rfrences}{}
\par
\list{\@biblabel{\@arabic\c@enumiv}}
{\settowidth\labelwidth{\@biblabel{#1}}}
\leftmargin\labelwidth
\advance\leftmargin\labelsep
\@openbib@code
\usecounter{enumiv}
\let\p@enumiv\@empty
\renewcommand\theenumiv{\@arabic\c@enumiv}
\sloppy
\clubpenalty4000
\@clubpenalty \clubpenalty
\widowpenalty4000%
\sfcode`\.\@m
{\def\@noitemerr
{\@latex@warning{Empty `thebibliography' environment}}%
\endlist}
}

% fancyhdr parameters
\newlength\debordement\setlength\debordement{0pt}
\pagestyle{fancy}
\fancyheadoffset{\debordement}
\fancyfootoffset{\debordement}
\renewcommand{\chaptermark}[1]{\markboth{\normalfont\normalsize\sffamily\textsc{\thechapter. \ #1}}{}}
%\renewcommand{\sectionmark}[1]{\markright{\normalfont\normalsize\sffamily\thesection\hspace{6pt}\protect\raisebox{0.8mm}{\tiny$\bullet$}\hspace{3pt}#1}{}}
\renewcommand{\sectionmark}[1]{\markright{\normalfont\normalsize\sffamily\thesection\hspace{5pt}#1}{}}
\fancyhf{} \fancyhead[LE,RO]{\normalfont\normalsize\bfseries\sffamily\thepage}
\fancyhead[LO]{\itshape{\rightmark}}
\fancyhead[RE]{\itshape{\leftmark}}
\renewcommand{\headrulewidth}{0.5pt}
\addtolength{\headheight}{0.5pt}
\renewcommand{\footrulewidth}{0pt}
\fancypagestyle{plain}{
\fancyhead{}
\renewcommand{\headrulewidth}{0pt}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% enlve l'entte des pages de fin de chapitre si nombre de pages impair
\renewcommand{\cleardoublepage}{%
\clearpage\ifodd\c@page\else
\hbox{}
\vspace*{\fill}
\thispagestyle{empty}
\newpage
\fi
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dfinition de l'apparence des sections et sous-sections
\renewcommand{\@seccntformat}[1]{\llap{\textcolor{ocre}{\csname the#1\endcsname}\hspace{0.5em}}}
                                      
\renewcommand{\section}{\@startsection{section}{1}{\z@}
                       {-5ex \@plus -1ex \@minus -.4ex}%
                       {1ex \@plus.2ex }%
                       {\normalfont\Large\sffamily\bfseries}}
\renewcommand{\subsection}{\@startsection {subsection}{2}{\z@}
                          {-4ex \@plus -0.1ex \@minus -.4ex}%
                          {0.5ex \@plus.2ex }%
                          {\normalfont\fontsize{12}{16}\sffamily\bfseries}}
\renewcommand{\subsubsection}{\@startsection {subsubsection}{3}{\z@}
                          {-3ex \@plus -0.1ex \@minus -.2ex}%
                          {0.2ex \@plus.2ex }%
                          {\normalfont\fontsize{11}{16}\sffamily\bfseries}}
                          
\renewcommand\paragraph{\@startsection{paragraph}{4}{\z@}%
                                    {-3ex \@plus-.2ex \@minus .2ex}%
                                    {-2ex}%
                                    {\normalfont\fontsize{11}{13}\sffamily\bfseries}}
\renewcommand\subparagraph{\@startsection{subparagraph}{5}{\z@}%
                                       {-2ex \@plus-.1ex \@minus .2ex}%
                                       {0.1ex}%
                                      {\normalfont\normalsize\sffamily\bfseries}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
